unit sysutil2;{$ifdef fpc}{$smartlink on}{$endif}
{$define widechar}
{$ifdef widechar}{$h+}{$else}{$h-}{$endif}
interface
uses windows;
const
 fmopenread      =$00;
 fmopenwrite     =$01;
 fmopenreadwrite =$02;
 fmsharecompat   =$00;
 fmshareexclusive=$10;
 fmsharedenywrite=$20;
 fmsharedenyread =$30;
 fmsharedenynone =$40;

 fareadonly =$01;
 fahidden   =$02;
 fasysfile  =$04;
 favolumeid =$08;
 fadirectory=$10;
 faarchive  =$20;
 faanyfile  =$3f;

 readonly =$01;
 hidden   =$02;
 sysfile  =$04;
 volumeid =$08;
 directory=$10;
 archive  =$20;
 anyfile  =$3f;

type
 wordrec=packed record
  lo,hi:byte;
 end;
 longrec=packed record
  lo,hi:word;
 end;
 pbytearray=^tbytearray;
 tbytearray=array[0..32767] of byte;
 pwordarray=^twordarray;
 twordarray=array[0..16383] of word;
 tprocedure=procedure;
 tfilename=string;
{$h-}
 tsearchrec=record
  time:integer;
  size:integer;
  attr:integer;
  name:tfilename;
  excludeattr:integer;
  findhandle:thandle;
  finddata:twin32finddata;
 end;
 searchrec=tsearchrec;
 tfilerec=record
  handle:integer;
  mode:integer;
  recsize:integer;
  private:array[1..28] of byte;
  userdata:array[1..32] of byte;
  name:array[0..259] of char;
 end;
 ptextbuf=^ttextbuf;
 ttextbuf=array[0..127] of char;
 ttextrec=record
  handle:integer;
  mode:integer;
  bufsize:integer;
  bufpos:integer;
  bufend:integer;
  bufptr:pchar;
  openfunc:pointer;
  inoutfunc:pointer;
  flushfunc:pointer;
  closefunc:pointer;
  userdata:array[1..32] of byte;
  name:array[0..259] of char;
  buffer:ttextbuf;
 end;

type pathstr=string[255];
function getenv(envvar:string):string;
function fexpand(const path:pathstr):pathstr;
procedure getfattr(var f; var attr: word);
procedure getftime(var f; var time: longint);
procedure setfattr(var f; attr: word);
procedure setftime(var f; time: longint);

{$ifdef widechar}{$h+}{$endif}

function allocmem(size:integer):pointer;
procedure addexitproc(proc:tprocedure);
function strtointdef(const s:string;default:integer):integer;

function findfirst(const path:string;attr:integer;var f:tsearchrec):integer;
function findnext(var f:tsearchrec):integer;
procedure findclose(var f:tsearchrec);

function diskfree(drive:byte):integer;
function disksize(drive:byte):integer;

function strpas(str:pchar):string;
function strlen(str:pchar):integer;
function strcomp(str1,str2:pchar):integer;assembler;

implementation

function allocmem(size:integer):pointer;
begin
 getmem(result,size);
 fillchar(result^,size,0);
end;

type
 pexitprocinfo=^texitprocinfo;
 texitprocinfo=record
  next:pexitprocinfo;
  saveexit:pointer;
  proc:tprocedure;
 end;

const
 exitproclist:pexitprocinfo=nil;

procedure doexitproc;far;
var
 p:pexitprocinfo;
 proc:tprocedure;
begin
 p:=exitproclist;
 exitproclist:=p^.next;
 exitproc:=p^.saveexit;
 proc:=p^.proc;
 dispose(p);
 proc;
end;

procedure addexitproc(proc:tprocedure);
var
 p:pexitprocinfo;
begin
 new(p);
 p^.next:=exitproclist;
 p^.saveexit:=exitproc;
 p^.proc:=proc;
 exitproclist:=p;
 exitproc:=@doexitproc;
end;

function strtointdef(const s:string;default:integer):integer;
var
 e:integer;
begin
 val(s,result,e);
 if e<>0 then result:=default;
end;

function filegetdate(handle:integer):integer;
var
 filetime,localfiletime:tfiletime;
begin
 if getfiletime(handle,nil,nil,@filetime) and filetimetolocalfiletime(filetime,localfiletime) and filetimetodosdatetime(localfiletime,longrec(result).hi,longrec(result).lo) then exit;result:=-1;
end;

function filesetdate(handle:integer;age:integer):integer;
var
  localfiletime,filetime:tfiletime;
begin
 result:=0;
 if dosdatetimetofiletime(longrec(age).hi,longrec(age).lo,localfiletime) and
  localfiletimetofiletime(localfiletime,filetime) and
  setfiletime(handle,nil,nil,@filetime) then exit;
 result:=getlasterror;
end;

function findmatchingfile(var f:tsearchrec):integer;
var
  localfiletime:tfiletime;
begin
 with f do begin
  while finddata.dwfileattributes and excludeattr<>0 do
   if not findnextfile(findhandle,finddata) then begin
    result:=getlasterror;
    exit;
   end;
   filetimetolocalfiletime(finddata.ftlastwritetime,localfiletime);
   filetimetodosdatetime(localfiletime,longrec(time).hi,longrec(time).lo);
   size:=finddata.nfilesizelow;
   attr:=finddata.dwfileattributes;
   name:=finddata.cfilename;
  end;
 result:=0;
end;

function findfirst(const path:string;attr:integer;
 var f:tsearchrec):integer;
const
 faspecial=fahidden or fasysfile or favolumeid or fadirectory;
begin
 f.excludeattr:=not attr and faspecial;
 f.findhandle:=findfirstfile(pchar(path),f.finddata);
 if f.findhandle<>invalid_handle_value then begin
  result:=findmatchingfile(f);
  if result<>0 then findclose(f);
 end else result:=getlasterror;
end;

function findnext(var f:tsearchrec):integer;
begin
 if findnextfile(f.findhandle,f.finddata) then result:=findmatchingfile(f) else result:=getlasterror;
end;

procedure findclose(var f:tsearchrec);
begin
 if f.findhandle<>invalid_handle_value then windows.findclose(f.findhandle);
end;

function expandfilename(const filename:string):string;
var
 fname:pchar;
 buffer:array[0..max_path-1] of char;
begin
 setstring(result,buffer,getfullpathname(pchar(filename),sizeof(buffer),buffer,fname));
end;

function disksize(drive:byte):integer;
var
 rp:array[0..3] of char;
 rpt:pchar;
 sec,byt,free,total:integer;
begin
 if drive>0 then begin
  rp[0]:=char(drive+64);
  rp[1]:=':';
  rp[2]:='\';
  rp[3]:=#0;
  rpt:=rp;
 end else rpt:=nil;
 if getdiskfreespace(rpt,sec,byt,free,total) then result:=sec*byt*total else result:=-1;
end;

function diskfree(drive:byte):integer;
var
 rp:array[0..3] of char;
 rpt:pchar;
 sec,byt,free,total:integer;
begin
 if drive>0 then begin
  rp[0]:=char(drive+64);
  rp[1]:=':';
  rp[2]:='\';
  rp[3]:=#0;
  rpt:=rp;
 end else rpt:=nil;
 if getdiskfreespace(rpt,sec,byt,free,total) then result:=sec*byt*free else result:=-1;
end;

function strpas(str:pchar):string;
begin
 result:=str;
end;

{$h-}

function strlen(str:pchar):integer;assembler;
asm
 mov   edx,edi
 mov   edi,eax
 mov   ecx,0ffffffffh
 xor   al,al
 repne scasb
 mov   eax,0fffffffeh
 sub   eax,ecx
 mov   edi,edx
end;

function strcomp(str1,str2:pchar):integer;assembler;
asm
 push  edi
 push  esi
 mov   edi,edx
 mov   esi,eax
 mov   ecx,0ffffffffh
 xor   eax,eax
 repne scasb
 not   ecx
 mov   edi,edx
 xor   edx,edx
 repe  cmpsb
 mov   al,[esi-1]
 mov   dl,[edi-1]
 sub   eax,edx
 pop   esi
 pop   edi
end;

function upcasea(const s:shortstring):shortstring;
var
 i:longint;
begin
 upcasea[0]:=s[0];
 for i:=1 to length(s) do upcasea[i]:=upcase(s[i]);
end;

function getenv(envvar:string):string;
var
 s:string;
 i:longint;
 hp,p:pchar;
begin
 getenv:='';
 p:=getenvironmentstrings;
 hp:=p;
 while hp^<>#0 do begin
  s:=strpas(hp);
  i:=pos('=',s);
  if upcasea(copy(s,1,i-1))=upcasea(envvar) then begin
   getenv:=copy(s,i+1,length(s)-i);
   break;
  end;
  hp:=hp+strlen(hp)+1;
 end;
 freeenvironmentstrings(p);
end;

function fexpand(const path:pathstr):pathstr;
var
   s,pa:pathstr;
   i,j :longint;
begin
   getdir(0,s);
   i:=ioresult;
   pa:=path;
   for i:=1 to length(pa) do
    if pa[i]='/' then pa[i]:='\';
   if (length(pa)>1) and (pa[2]=':') and (pa[1] in ['A'..'Z','a'..'z']) then
     begin
        if (pa[1] in ['a'..'z']) then
         pa[1]:=Chr(Ord(Pa[1])-32);
        getdir(ord(pa[1])-ord('A')+1,s);
        if (ord(pa[0])>2) and (pa[3]<>'\') then
          if pa[1]=s[1] then
            pa:=s+'\'+copy (pa,3,length(pa))
          else
            pa:=pa[1]+':\'+copy (pa,3,length(pa))
     end
   else
     if pa[1]='\' then pa:=s[1]+':'+pa
     else if s[0]=#3 then pa:=s+pa
     else pa:=s+'\'+pa;
 if length(pa)=2 then
  begin
    getdir(byte(pa[1])-64,s);
    i:=ioresult;
    pa:=s;
  end;
   while pos ('\.\',pa)<>0 do
    delete (pa,pos('\.\',pa),2);
   repeat
     i:=pos('\..\',pa);
     if i<>0 then
      begin
        j:=i-1;
        while (j>1) and (pa[j]<>'\') do
         dec (j);
        if pa[j+1]=':' then j:=3;
        delete (pa,j,i-j+3);
      end;
   until i=0;
   i:=pos('\..',pa);
   if i<>0 then
    begin
      if i=length(pa)-2 then
       begin
         j:=i-1;
         while (j>1) and (pa[j]<>'\') do
          dec (j);
         delete (pa,j,i-j+3);
       end;
       pa:=pa+'\';
     end;
   if (length(pa)>0) and (pa[length(pa)]='.') then
    dec(byte(pa[0]));
   if ((length(pa)>3) and (pa[length(pa)]='\')) and (path[length(path)]<>'\') then
    dec(byte(pa[0]));
   if length(path)=2 then pa:=pa+'\';
   fexpand:=pa;
end;

function dostowintime (dtime:longint;var wtime : tfiletime):longbool;
var
 lft:tfiletime;
begin
 dostowintime:=dosdatetimetofiletime(longrec(dtime).hi,longrec(dtime).lo,lft) and localfiletimetofiletime(lft,wtime);
end;


function wintodostime (const wtime : tfiletime;var dtime:longint):longbool;
var
 lft:tfiletime;
begin
  wintodostime:=filetimetolocalfiletime(wtime,lft) and filetimetodosdatetime(lft,longrec(dtime).hi,longrec(dtime).lo);
end;

procedure getfattr(var f;var attr : word);
var
 l:longint;
begin
 l:=getfileattributes(tfilerec(f).name);
 if l=$ffffffff then attr:=0 else attr:=l and $ffff;
end;

procedure setfattr(var f;attr : word);
begin
 setfileattributes(tfilerec(f).name,attr);
end;

procedure getftime(var f;var time : longint);
var
 ft:tfiletime;
begin
 if getfiletime(tfilerec(f).handle,nil,nil,@ft) and wintodostime(ft,time) then exit else time:=0;
end;

procedure setftime(var f;time : longint);
var
 ft:tfiletime;
begin
 if dostowintime(time,ft) then setfiletime(tfilerec(f).handle,nil,nil,@ft);
end;

end.
