{$ifdef win32}{$apptype console}{$h-,o+}{$else}{$M 65520,0,655360}{$endif}{$ifdef fpc}{$smartlink on}{$endif}
uses b_crypt,crypt{$ifdef win32},windows{$endif};
const
 bufsize=8192;
var
 obuf,buf:array[1..bufsize]of byte;
 tbd:tblowfishdata;
 tcd:tcast128data;
 trd:trijndaeldata;
 ttd:ttwofishdata;
 tid:tideadata;
 key:array[1..64] of byte;
 x,i,blen,btim:longint;

{$ifdef linux}{$define win32}{$endif}
{$ifdef win32}
const
 tik=1;
 testticks=5000;
{$else}
const
 tik=55;
 testticks=91;
function gettickcount:word;assembler;
asm
 mov ax,0
 int 1ah
 mov ax,dx
end;
{$endif}
procedure reporttime(s:string);
begin
 if btim<>0 then Writeln(s+': Rychlost:',blen div (btim*tik),' KB/s')
	    else Writeln(s+': Rychlost: Nemeritelna');
end;

begin
 Writeln('BCrypt speedtest by Bilbo');
 Writeln('-------------------------');
 for i:=1 to bufsize do buf[i]:=random(256);
 for i:=1 to 64 do key[i]:=random(256);

 blen:=0;
 i:=gettickcount;
 rijndaelinit(trd,key,256,nil);
 repeat
  rijndaeldecryptCBC(trd,buf,obuf,bufsize);
  inc(blen,bufsize);
 until gettickcount-i>testticks;
 rijndaelburn(trd);
 btim:=gettickcount-i;
 reporttime('Rijndael CBC');

 blen:=0;
 i:=gettickcount;
 twofishinit(ttd,key,256,nil);
 repeat
  twofishdecryptCBC(ttd,buf,obuf,bufsize);
  inc(blen,bufsize);
 until gettickcount-i>testticks;
 twofishburn(ttd);
 btim:=gettickcount-i;
 reporttime('Twofish CBC ');

 blen:=0;
 i:=gettickcount;
 blowfishinit(tbd,key,256,nil);
 repeat
  blowfishdecryptCBC(tbd,buf,obuf,bufsize);
  inc(blen,bufsize);
 until gettickcount-i>testticks;
 blowfishburn(tbd);
 btim:=gettickcount-i;
 reporttime('Blowfish CBC');

 blen:=0;
 i:=gettickcount;
 cast128init(tcd,key,256,nil);
 repeat
  cast128decryptCBC(tcd,buf,obuf,bufsize);
  inc(blen,bufsize);
 until gettickcount-i>testticks;
 cast128burn(tcd);
 btim:=gettickcount-i;
 reporttime('Cast128 CBC ');

 blen:=0;
 i:=gettickcount;
 ideainit(tid,key,256,nil);
 repeat
  ideadecryptCBC(tid,buf,obuf,bufsize);
  inc(blen,bufsize);
 until gettickcount-i>testticks;
 ideaburn(tid);
 btim:=gettickcount-i;
 reporttime('Idea CBC    ');

 blen:=0;
 i:=gettickcount;
 repeat
  x:=crcw(buf,bufsize);
  inc(blen,bufsize);
 until gettickcount-i>testticks;
 btim:=gettickcount-i;
 reporttime('CRC checksum');
end.
