{$A+,B-,D+,E+,F-,G+,I-,L+,N-,P-,Q-,R-,S-,T-,V+,X+,Y+}{$ifdef fpc}{$smartlink on}{$endif}
{$ifdef win32}{$define windows}{$h-,o+}
{$else}
{$M 65520,0,655360}{$o-}
{$endif}
unit crtc;

interface
const
 Black       =0;
 Blue        =1;
 Green       =2;
 Cyan        =3;
 Red         =4;
 Magenta     =5;
 Brown       =6;
 LightGray   =7;
 DarkGray    =8;
 LightBlue   =9;
 LightGreen  =10;
 LightCyan   =11;
 LightRed    =12;
 LightMagenta=13;
 Yellow      =14;
 White       =15;

procedure clrscr;
function KeyPressed:boolean;
function readkey:char;
function wherex:word;
function wherey:word;
procedure gotoxy(x,y:integer);

{$ifndef windows}
var
 textattr:byte;
procedure Sound(ms:word);
procedure NoSound;
procedure clreol;
procedure Delay(ms:word);

{$else}
type
 TConsoleColour=(ccBlack,ccRed,ccGreen,ccBlue,ccMagenta,
  ccYellow,ccCyan,ccWhite);
 TConsoleInfo=record
  Width:Integer;
  Height:Integer;
  CursorLeft:Integer;
  CursorTop:Integer;
  Foreground:TConsoleColour;
  Background:TConsoleColour;
 end;

procedure cuSetTitle(Title:string);
procedure cuWriteLnCentred(Text:string);
procedure cuSetTextColour(Foreground,Background:TConsoleColour);
procedure cuSetOutputColour(Foreground,Background:TConsoleColour);
procedure cuHideCursor;
procedure cuShowCursor;
function cuGetConsoleInfo:TConsoleInfo;
procedure delay(dwMilliseconds: longint);stdcall;

{$endif}

implementation
{$ifndef windows}
var
 scancode:byte;
const
 windmaxx=79;
 windmaxy=24;
procedure clreol;assembler;
asm
  MOV AH,3
  XOR BH,BH
  int 10h
  MOV AX,6*256
  MOV BH,TextAttr
  MOV CX,DX
  MOV DL,WindMaxX
  int 10h
end;

procedure ClrScr; assembler;
asm
 mov ah,0Fh
 int 10h
 xor ah,ah
 int 10h;
end;

function WhereX:word;assembler;
asm
 MOV	AH,3
 XOR	BH,BH
 int 10h
 MOV  AL,DL
 XOR  AH,AH
end;

function WhereY:word;assembler;
asm
 MOV	AH,3
 XOR	BH,BH
 int 10h
 MOV  AL,DH
 XOR  AH,AH
end;

procedure gotoxy(x,y:integer);assembler;
asm
 MOV DL,[x.byte]
 MOV DH,[y.byte]
 MOV AH,2
 XOR BH,BH
 int 10h
end;

function KeyPressed:boolean;assembler;
asm
 CMP  ScanCode,0
 JNE  @l1
 MOV  AH,1
 INT  16H
 MOV  AL,0
 JE   @l2
@l1:
 MOV  AL,1
@l2:
end;

procedure Delay( ms:Word); assembler;
  asm
    mov ax,1000
    mul [ms]
    mov cx,dx
    mov dx,ax
    mov ax,$8600
    int $15
  end;

procedure Sound(ms:word);assembler;
asm
  mov  bx,[ms]
  MOV  AX,34DDH
  MOV  DX,0012H
  CMP  DX,BX
  JNC  @@2
  DIV  BX
  MOV  BX,AX
  IN   AL,61H
  TEST AL,3
  JNZ  @@1
  OR   AL,3
  OUT  61H,AL
  MOV  AL,0B6H
  OUT  43H,AL
@@1:  MOV	AL,BL
  OUT  42H,AL
  MOV  AL,BH
  OUT  42H,AL
@@2:
end;

procedure NoSound;assembler;
asm
  IN	AL,61H
  and	AL,0FCH
  OUT	61H,AL
end;

function ReadKey:char;assembler;
asm
 MOV  AL,ScanCode
 MOV  ScanCode,0
 OR   AL,AL
 JNE  @l1
 XOR  AH,AH
 INT  16H
 OR   AL,AL
 JNE  @l1
 MOV  ScanCode,AH
 OR   AH,AH
 JNE  @l1
 MOV  AL,'C'-64
@l1:
end;
{$else}

uses windows;
type coord=tcoord;
function ColoursToAttributes(Foreground,Background:TConsoleColour):Word;
var
 wAttributes:Word;
begin
 wAttributes:=0;
 case Foreground of
  ccRed:wAttributes:=wAttributes or FOREGROUND_RED;
  ccGreen:wAttributes:=wAttributes or FOREGROUND_GREEN;
  ccBlue:wAttributes:=wAttributes or FOREGROUND_BLUE;
  ccMagenta:wAttributes:=wAttributes or FOREGROUND_RED or FOREGROUND_BLUE;
  ccYellow:wAttributes:=wAttributes or FOREGROUND_RED or FOREGROUND_GREEN;
  ccCyan:wAttributes:=wAttributes or FOREGROUND_GREEN or FOREGROUND_BLUE;
  ccWhite:wAttributes:=wAttributes or FOREGROUND_RED or FOREGROUND_BLUE or
      FOREGROUND_GREEN;
 end;
  case Background of
    ccRed:wAttributes:=wAttributes or BACKGROUND_RED;
    ccGreen:wAttributes:=wAttributes or BACKGROUND_GREEN;
    ccBlue:wAttributes:=wAttributes or BACKGROUND_BLUE;
    ccMagenta:wAttributes:=wAttributes or BACKGROUND_RED or BACKGROUND_BLUE;
    ccYellow:wAttributes:=wAttributes or BACKGROUND_RED or BACKGROUND_GREEN;
    ccCyan:wAttributes:=wAttributes or BACKGROUND_GREEN or BACKGROUND_BLUE;
    ccWhite:wAttributes:=wAttributes or BACKGROUND_RED or BACKGROUND_BLUE or
        BACKGROUND_GREEN;
  end;
  ColoursToAttributes:=wAttributes;
end;

procedure AttributesToColours(Attributes:Word; var Foreground,
  Background:TConsoleColour);
begin
  Foreground:=ccBlack;
  if (Attributes and (FOREGROUND_GREEN or FOREGROUND_RED or
    FOREGROUND_BLUE))<>0 then
    Foreground:=ccWhite
  else if (Attributes and (FOREGROUND_RED or FOREGROUND_BLUE))<>0 then
    Foreground:=ccMagenta
  else if (Attributes and (FOREGROUND_RED or FOREGROUND_GREEN))<>0 then
    Foreground:=ccYellow
  else if (Attributes and (FOREGROUND_BLUE or FOREGROUND_GREEN))<>0 then
    Foreground:=ccCyan
  else if (Attributes and FOREGROUND_RED)<>0 then
    Foreground:=ccRed
  else if (Attributes and FOREGROUND_GREEN)<>0 then
    Foreground:=ccGreen
  else if (Attributes and FOREGROUND_BLUE)<>0 then
    Foreground:=ccBlue;

  Background:=ccBlack;
  if (Attributes and (BACKGROUND_GREEN or BACKGROUND_RED or
    BACKGROUND_BLUE))<>0 then
    Background:=ccWhite
  else if (Attributes and (BACKGROUND_RED or BACKGROUND_BLUE))<>0 then
    Background:=ccMagenta
  else if (Attributes and (BACKGROUND_RED or BACKGROUND_GREEN))<>0 then
    Background:=ccYellow
  else if (Attributes and (BACKGROUND_BLUE or BACKGROUND_GREEN))<>0 then
    Background:=ccCyan
  else if (Attributes and BACKGROUND_BLUE)<>0 then
    Background:=ccBlue
  else if (Attributes and BACKGROUND_GREEN)<>0 then
    Background:=ccGreen
  else if (Attributes and BACKGROUND_RED)<>0 then
    Background:=ccRed;
end;

function cuGetConsoleInfo:TConsoleInfo;
var
 ConsInfo:TConsoleScreenBufferInfo;
 res:TConsoleInfo;
begin
 GetConsoleScreenBufferInfo(GetStdHandle(STD_OUTPUT_HandLE),ConsInfo);
 cuGetConsoleInfo.Width:=ConsInfo.dwSize.X;
 cuGetConsoleInfo.Height:=ConsInfo.dwSize.Y;
 cuGetConsoleInfo.CursorLeft:=ConsInfo.dwCursorPosition.X;
 cuGetConsoleInfo.CursorTop:=ConsInfo.dwCursorPosition.Y;
 AttributesToColours(ConsInfo.wAttributes,res.Foreground,res.Background);
 cuGetConsoleInfo:=res;
end;

function wherex:word;
var
 ConsInfo:TConsoleScreenBufferInfo;
begin
 GetConsoleScreenBufferInfo(GetStdHandle(STD_OUTPUT_HANDLE),ConsInfo);
 wherex:=ConsInfo.dwCursorPosition.X;
end;

function wherey:word;
var
 ConsInfo:TConsoleScreenBufferInfo;
begin
 GetConsoleScreenBufferInfo(GetStdHandle(STD_OUTPUT_HANDLE),ConsInfo);
 wherey:=ConsInfo.dwCursorPosition.Y;
end;

procedure clrscr;
var
  sbi:TConsoleScreenBufferInfo;
  i:Integer;
begin
  GetConsoleScreenBufferInfo(GetStdHandle(STD_OUTPUT_HANDLE),sbi);
  for i:=0 to sbi.dwSize.y do
    writeln(StringOfChar(' ',sbi.dwSize.x));
end;

procedure cuSetTitle(Title:string);
begin
 title:=title+#0;
 SetConsoleTitle(@(Title[1]));
end;

procedure cuSetTextColour(Foreground,Background:TConsoleColour);
begin
  SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE),
    ColoursToAttributes(Foreground,Background));
end;

procedure cuSetOutputColour(Foreground,Background:TConsoleColour);
var
 Attributes:WORD;
 StartPos:COORD;
 dwNoWritten:DWORD;
 ConsoleInfo:TConsoleInfo;
begin
 Attributes:=ColoursToAttributes(Foreground,Background);
 StartPos.X:=0;
 StartPos.Y:=0;
 ConsoleInfo:=cuGetConsoleInfo;
 FillConsoleOutputAttribute(GetStdHandle(STD_OUTPUT_HANDLE),Attributes,
    (ConsoleInfo.Width*ConsoleInfo.Height),StartPos,dwNoWritten);
end;

procedure gotoxy(x,y:integer);
var
 NewPos:COORD;
begin
 NewPos.X:=x;
 NewPos.Y:=y;
 SetConsoleCursorPosition(GetStdHandle(STD_OUTPUT_HANDLE),NewPos);
end;

procedure cuHideCursor;
var
  CursorInfo:TConsoleCursorInfo;
begin
  GetConsoleCursorInfo(GetStdHandle(STD_OUTPUT_HANDLE),CursorInfo);
  CursorInfo.bVisible:=false;
  SetConsoleCursorInfo(GetStdHandle(STD_OUTPUT_HANDLE),CursorInfo);
end;

procedure cuShowCursor;
var
  CursorInfo:TConsoleCursorInfo;
begin
  GetConsoleCursorInfo(GetStdHandle(STD_OUTPUT_HANDLE),CursorInfo);
  CursorInfo.bVisible:=true;
  SetConsoleCursorInfo(GetStdHandle(STD_OUTPUT_HANDLE),CursorInfo);
end;

procedure cuWriteLnCentred(Text:string);
var
  InsertText:string;
  InsertNum:Integer;
  n:Integer;
  sbi:TConsoleScreenBufferInfo;
begin
  GetConsoleScreenBufferInfo(GetStdHandle(STD_OUTPUT_HANDLE),sbi);
  InsertNum:=(sbi.dwSize.X - Length(Text)) div 2;
  InsertText:='';
  for n:=1 to InsertNum do
    InsertText:=InsertText + ' ';
  InsertText:=InsertText + Text;
  WriteLn(InsertText);
end;

var
 ScanCode:byte;
 SpecialKey:boolean;

procedure RemapScanCode (SCode:byte; CtrlKeyState:byte);
var
 AltKey,CtrlKey,ShiftKey:boolean;
const
 CtrlKeypadKeys:array[$47..$53] of byte=($77,$8D,$84,$8E,$73,$8F,$74,$4E,$75,$91,$76,$92,$93);
begin
 scancode:=scode;
 AltKey:=((CtrlKeyState and (RIGHT_ALT_PRESSED OR LEFT_ALT_PRESSED))>0);
 CtrlKey:=((CtrlKeyState and (RIGHT_CTRL_PRESSED OR LEFT_CTRL_PRESSED))>0);
 ShiftKey:=((CtrlKeyState and SHIFT_PRESSED)>0);
 if AltKey then
  case ScanCode of
   $02..$0D:inc(ScanCode,$76);
   $3B..$44:inc(Scancode,$2D);
   $57..$58:inc(Scancode,$34);
   $47..$49,$4B,$4D,$4F..$53:inc(Scancode,$50);
   $1C:Scancode:=$A6;
   $35:Scancode:=$A4;
  end
 else if CtrlKey then
  case Scancode of
   $0F:Scancode:=$94;
   $3B..$44:inc(Scancode,$23);
   $57..$58:inc(Scancode,$32);
   $35:Scancode:=$95;
   $37:Scancode:=$96;
   $47..$53:Scancode:=CtrlKeypadKeys[Scancode];
  end
 else if ShiftKey then
  case Scancode of
   $3B..$44:inc(Scancode,$19);
   $57..$58:inc(Scancode,$30);
  end
 else
  case Scancode of
   $57..$58:inc(Scancode,$2E);
  end;
end;

function keypressed:boolean;
var
 nevents,nread:dword;
 i: longint;
 buf:tinputrecord;
begin
 keypressed:=false;
 if scancode<>0 then keypressed:=true
 else begin
  nevents:=0;
  getnumberofconsoleinputevents(getstdhandle(std_input_handle),nevents);
  for i:=1 to nevents do begin
   readconsoleinputa(getstdhandle(std_input_handle),buf,1,nread);
   if buf.eventtype=key_event then
   if buf.{$ifdef ver140}event.{$endif}keyevent.bkeydown then begin
    keypressed:=true;
    if ord(buf.{$ifdef ver140}event.{$endif}keyevent.asciichar)=0 then begin
     specialkey:=true;
     remapscancode(buf.{$ifdef ver140}event.{$endif}keyevent.wvirtualscancode,
                 buf.{$ifdef ver140}event.{$endif}keyevent.dwcontrolkeystate);
    end else begin
     specialkey:=false;
     scancode:=ord(buf.{$ifdef ver140}event.{$endif}keyevent.asciichar);
    end;
    break;
   end;
  end;
 end;
end;
procedure delay(dwMilliseconds: longint);stdcall;external 'kernel32.dll' name 'Sleep';

function readkey: char;
begin
 while not keypressed do delay(1);
 if specialkey then begin
  readkey:=#0;
  specialkey:=false;
 end else begin
  readkey:=chr(scancode);
  scancode:=0;
 end;
end;

{$endif}

end.